{
  Example of custom text items.
}

unit MainFrm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics,
  Controls, Forms, Dialogs, RVStyle, RVScroll, RichView, RVEdit, CRVData,
  RVTypes,
  CustomTextItem;

type
  TfrmMain = class(TForm)
    RichViewEdit1: TRichViewEdit;
    RVStyle1: TRVStyle;
    procedure FormCreate(Sender: TObject);
    procedure RVStyle1DrawStyleText(Sender: TRVStyle; const s: TRVUnicodeString;
      Canvas: TCanvas; StyleNo, SpaceAtLeft, ALeft, ATop, AWidth, AHeight,
      BaseLine, TextWidth, SpaceCount: Integer; DrawState: TRVTextDrawStates;
      Printing, PreviewCorrection, ForMetafile: Boolean;
      ColorMode: TRVColorMode; DefBiDiMode: TRVBiDiMode; RefCanvas: TCanvas;
      LeftNoExpIndex, RightNoExpIndex: Integer; PSaD: PRVScreenAndDevice;
      var DoDefault: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  RichViewEdit1.Clear;
  RichViewEdit1.AddNL('Hello', 0, 0);
  with RichViewEdit1.GetItem(RichViewEdit1.ItemCount - 1) as TRVMyTextItemInfo do
  begin
    BorderWidth := 1;
    AdditionalText := 'Sample additional text';
  end;
  RichViewEdit1.Add(' ', 0);
  RichViewEdit1.Add('world!', 0);
  with RichViewEdit1.GetItem(RichViewEdit1.ItemCount - 1) as TRVMyTextItemInfo do
  begin
    BorderWidth := 2;
    BorderColor := clSkyBlue;
  end;
  RichViewEdit1.Add(' ', 0);
  RichViewEdit1.Format;
end;

procedure TfrmMain.RVStyle1DrawStyleText(Sender: TRVStyle;
  const s: TRVUnicodeString; Canvas: TCanvas; StyleNo, SpaceAtLeft, ALeft, ATop,
  AWidth, AHeight, BaseLine, TextWidth, SpaceCount: Integer;
  DrawState: TRVTextDrawStates; Printing, PreviewCorrection,
  ForMetafile: Boolean; ColorMode: TRVColorMode; DefBiDiMode: TRVBiDiMode;
  RefCanvas: TCanvas; LeftNoExpIndex, RightNoExpIndex: Integer;
  PSaD: PRVScreenAndDevice; var DoDefault: Boolean);
var
  Item: TRVMyTextItemInfo;
  PenColor, BrushColor: TColor;
  PenStyle: TPenStyle;
  BrushStyle: TBrushStyle;
  PenWidth: Integer;

  procedure StoreCanvas;
  begin
    PenColor   := Canvas.Pen.Color;
    PenStyle   := Canvas.Pen.Style;
    PenWidth   := Canvas.Pen.Width;
    BrushColor := Canvas.Brush.Color;
    BrushStyle := Canvas.Brush.Style;
  end;

  procedure ReStoreCanvas;
  begin
    Canvas.Pen.Color := PenColor;
    Canvas.Pen.Style := PenStyle;
    Canvas.Pen.Width := PenWidth;
    Canvas.Brush.Color := BrushColor;
    Canvas.Brush.Style := BrushStyle;
  end;

begin
  if not (TCustomRVData(Sender.RVData).GetItem(Sender.ItemNo) is TRVMyTextItemInfo) then
    exit;
  Item := TRVMyTextItemInfo(TCustomRVData(Sender.RVData).GetItem(Sender.ItemNo));
  if (Item.BorderColor <> clNone) and (Item.BorderWidth <> 0) then
  begin
    StoreCanvas;
    Canvas.Pen.Color := Item.BorderColor;
    Canvas.Pen.Style := psInsideFrame;
    Canvas.Pen.Width := Sender.GetAsDevicePixelsX(Item.BorderWidth,
      PSaD, RichViewEdit1.GetRealDocumentPixelsPerInch, 1);
    Canvas.Brush.Style := bsClear;
    Canvas.Rectangle(ALeft, ATop, ALeft + AWidth, ATop + AHeight);
    RestoreCanvas;
  end;
end;

end.
