unit SRVMainFrm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics,
  Controls, Forms, Dialogs, RVScroll, SclRView, RVEdit, RVStyle, RVTypes, CRVData,
  CustomTextItem;

type
  TfrmSRVMain = class(TForm)
    SRichViewEdit1: TSRichViewEdit;
    procedure FormCreate(Sender: TObject);
  private
    procedure DrawText(Sender: TRVStyle; const s: TRVUnicodeString;
      Canvas: TCanvas; StyleNo, SpaceAtLeft, ALeft, ATop, AWidth, AHeight,
      BaseLine, TextWidth, SpaceCount: Integer; DrawState: TRVTextDrawStates;
      Printing, PreviewCorrection, ForMetafile: Boolean;
      ColorMode: TRVColorMode; DefBiDiMode: TRVBiDiMode; RefCanvas: TCanvas;
      LeftNoExpIndex, RightNoExpIndex: Integer; PSaD: PRVScreenAndDevice;
      var DoDefault: Boolean);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmSRVMain: TfrmSRVMain;

implementation

{$R *.dfm}

procedure TfrmSRVMain.FormCreate(Sender: TObject);
var
  RVData: TCustomRVData;
begin
  SRichViewEdit1.RichViewEdit.Style.OnDrawStyleText := DrawText;
  SRichViewEdit1.RVHeader.Style.OnDrawStyleText := DrawText;
  SRichViewEdit1.RVFooter.Style.OnDrawStyleText := DrawText;

  SRichViewEdit1.Clear;
  // main document
  RVData := SRichViewEdit1.RichViewEdit.RVData;
  RVData.AddNL('Hello', 0, 0);
  with RVData.GetItem(RVData.ItemCount - 1) as TRVMyTextItemInfo do
  begin
    BorderWidth := 1;
    AdditionalText := 'Sample additional text';
  end;
  RVData.AddNL(' ', 0, -1);
  RVData.AddNL('world!', 0, -1);
  with RVData.GetItem(RVData.ItemCount - 1) as TRVMyTextItemInfo do
  begin
    BorderWidth := 2;
    BorderColor := clSkyBlue;
  end;
  RVData.AddNL(' ', 0, -1);
  // header
  RVData := SRichViewEdit1.SubDocuments[srvhftNormalHeader];
  RVData.AddNL('Header', 0, 0);
  with RVData.GetItem(RVData.ItemCount - 1) as TRVMyTextItemInfo do
  begin
    BorderWidth := 3;
    BorderColor := clMoneyGreen;
  end;
  SRichViewEdit1.Format;
end;


procedure TfrmSRVMain.DrawText(Sender: TRVStyle;
  const s: TRVUnicodeString; Canvas: TCanvas; StyleNo, SpaceAtLeft, ALeft, ATop,
  AWidth, AHeight, BaseLine, TextWidth, SpaceCount: Integer;
  DrawState: TRVTextDrawStates; Printing, PreviewCorrection,
  ForMetafile: Boolean; ColorMode: TRVColorMode; DefBiDiMode: TRVBiDiMode;
  RefCanvas: TCanvas; LeftNoExpIndex, RightNoExpIndex: Integer;
  PSaD: PRVScreenAndDevice; var DoDefault: Boolean);
var
  Item: TRVMyTextItemInfo;
  PenColor, BrushColor: TColor;
  PenStyle: TPenStyle;
  BrushStyle: TBrushStyle;
  PenWidth: Integer;

  procedure StoreCanvas;
  begin
    PenColor   := Canvas.Pen.Color;
    PenStyle   := Canvas.Pen.Style;
    PenWidth   := Canvas.Pen.Width;
    BrushColor := Canvas.Brush.Color;
    BrushStyle := Canvas.Brush.Style;
  end;

  procedure ReStoreCanvas;
  begin
    Canvas.Pen.Color := PenColor;
    Canvas.Pen.Style := PenStyle;
    Canvas.Pen.Width := PenWidth;
    Canvas.Brush.Color := BrushColor;
    Canvas.Brush.Style := BrushStyle;
  end;

begin
  if not (TCustomRVData(Sender.RVData).GetItem(Sender.ItemNo) is TRVMyTextItemInfo) then
    exit;
  Item := TRVMyTextItemInfo(TCustomRVData(Sender.RVData).GetItem(Sender.ItemNo));
  if (Item.BorderColor <> clNone) and (Item.BorderWidth <> 0) then
  begin
    StoreCanvas;
    Canvas.Pen.Color := Item.BorderColor;
    Canvas.Pen.Style := psInsideFrame;
    Canvas.Pen.Width := Sender.GetAsPixels(Item.BorderWidth, 96, 1);
    Canvas.Brush.Style := bsClear;
    Canvas.Rectangle(ALeft, ATop, ALeft + AWidth, ATop + AHeight);
    RestoreCanvas;
  end;
end;

end.
